import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrService {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  Name?: string;
  ServerId!: IType<number, bigint>;
  Address?: string;
  Port!: number;
  Domain?: string;
  Status!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrServiceSchema = defineEntity({
  class: IcrService,
  comment: '服务',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    Name: p.string().name('Name').nullable().comment('姓名'),
    ServerId: p.bigint().name('ServerId').columnType('bigint').comment('服务器id'),
    Address: p.string().name('Address').nullable().comment('地址'),
    Port: p.integer().name('Port').comment('端口'),
    Domain: p.string().name('Domain').nullable().comment('域名'),
    Status: p.integer().name('Status').comment('状态'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
